#ifndef _MMA8451_H_
#define _MMA8451_H_

#include <stdint.h>

// Adresse I2C du capteur
#define MMA8451_I2C_ADDRESS 0x1D

// Etat du capteur
#define MMA8451_SYSMOD 0x0B

// Registre d'identification
#define MMA8451_WHO_AM_I 0x0D

// Registres de données pour les axes X, Y et Z
#define MMA8451_OUT_X_MSB 0x01
#define MMA8451_OUT_X_LSB 0x02
#define MMA8451_OUT_Y_MSB 0x03
#define MMA8451_OUT_Y_LSB 0x04
#define MMA8451_OUT_Z_MSB 0x05
#define MMA8451_OUT_Z_LSB 0x06

// Registres de configuration
#define MMA8451_CTRL_REG1 0x2A
#define CTRL_REG1_ACTIVE 0
#define CTRL_REG1_DR0 3
#define CTRL_REG1_DR1 4
#define CTRL_REG1_DR2 5
#define MMA8451_CTRL_REG2 0x2B
#define MMA8451_CTRL_REG3 0x2C
#define MMA8451_CTRL_REG4 0x2D
#define MMA8451_CTRL_REG5 0x2E

struct mma8451_data {
  int16_t x;
  int16_t y;
  int16_t z;
};

// Initialise le capteur
void mma8451_init(uint8_t enable_interrupts);

// Écrit ou lit un octet dans le capteur
void mma8451_write_byte(uint8_t register_addr, uint8_t value);
uint8_t mma8451_read_byte(uint8_t register_addr);

// Réalise une mesure
struct mma8451_data mma8451_read();

#endif