#ifndef RING_BUFFER_H
#define RING_BUFFER_H

#include <stdint.h>

#define RING_BUFFER_SIZE 128

struct ring_buffer {
  uint8_t buffer[RING_BUFFER_SIZE];
  uint8_t head;
  uint8_t tail;
};

// Initialise le buffer circulaire
void ring_buffer_init(struct ring_buffer *rb);

// Ajoute un octet dans le buffer circulaire
void ring_buffer_put(struct ring_buffer *rb, uint8_t data);

// Récupère un octet du buffer circulaire
uint8_t ring_buffer_get(struct ring_buffer *rb);

// Indique si le buffer circulaire est vide
uint8_t ring_buffer_available_bytes(struct ring_buffer *rb);

// Indique si le buffer circulaire est plein
uint8_t ring_buffer_is_full(struct ring_buffer *rb);

#endif // RING_BUFFER_H
