#include "system_clock.h"
#include <avr/interrupt.h>
#include <avr/io.h>
#include <util/delay.h>

volatile static uint32_t system_clock_ms = 0;

// Overflow interrupt routine
ISR(TIMER1_COMPA_vect) { system_clock_ms++; }

void system_clock_init() {
  // Mode CTC, prescaler de 64
  TCCR1A = 0;
  TCCR1B = (1 << CS11) | (1 << CS10) | (1 << WGM12);

  // Overflow a 249 to get a 1ms period
  OCR1A = 249;

  // Active l'interruption d'overfow
  TIMSK1 = (1 << OCIE1A);
  TCNT1 = 0;
}

uint32_t system_clock() { return system_clock_ms; }